/*
    Compiler Core
    Copyright (C) 2012,2013 Ruslan Lopatin

    This file is part of o42a.

    o42a is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    o42a is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package org.o42a.core.ref;

import org.o42a.core.Scope;


public abstract class DerivedPred extends Pred {

	private final Pred base;

	public DerivedPred(Pred base, Scope scope) {
		super(scope);
		this.base = base;
	}

	public final Pred getBase() {
		return this.base;
	}

	@Override
	protected final Scope revert(Scope scope) {
		return getBase().revert(baseOf(scope));
	}

	protected abstract Scope baseOf(Scope derived);

}
